#ifndef GSSYS_INC
#define GSSYS_INC

/*  DOSSYS.H  - DOS dependent macros and includes.
	Copied to GSSYS.H by dosmake.   */

#include <conio.h>
#include <io.h>
#include <process.h>
#include <alloc.h>
#include <bios.h>
#include <dos.h>
#include <dir.h>
#include <graphics.h>
#include <values.h>
#include "svga256.h"
#include "svgas3.h"

typedef char huge ColorIndexType;

#define malloc farmalloc
#define calloc farcalloc
#define free farfree

/* prototypes for below (to keep the compiler quiet) */

#define GSmouseon()  asm { mov ax, 1;  int 33h; }
#define GSmouseoff() asm { mov ax, 2;  int 33h; }

#define PATH_SEPARATOR '/'

/***********************************************************************
  Set the drawing mode to XOR iff flag == TRUE
  otherwise, set drawing mode to COPY.
***********************************************************************/
#define GSPxormode(flag)  setwritemode(flag?XOR_PUT:COPY_PUT)
#define GSPinvertmode(flag)  setwritemode(flag?XOR_PUT:COPY_PUT)
#define GSstricmp stricmp

#endif /* #ifndef GSSYS_INC */
