#include <stdio.h>
#include <stdlib.h>

#include <ctype.h>
#include <string.h>

#include <sound.h>


#include "intrlib.h"
#include "intrtype.h"

struct macimg
  {
  int x;
  int y;
  char *data;
  } *macimg;

int theight;
RGBColor fillcolor, textcolor;
RGBColor macrgb[16];


WindowPtr mainWin;
CGrafPort myCGrafPort;
CGrafPtr myCGrafPtr;
GDHandle device, olddevice;


SndChannelPtr *snd;
SndCommand sndcmd;


void GSflushkbuf (void);
void GSflushkbuf (void)
  {
  }
  

char *stricmp (char *str1, char *str2)
  {
  int i, len;
  
  if ((len = strlen (str1)) != strlen (str2)) return (str1);
  for (i=0; i<len; i++)
    {
    if (tolower(str1[i]) != tolower(str2[i]))
      return (str1);
    }
  return (0);  
  }
  
char *itoa (int val, char *str, int radix)
  {
  int i = 0;
  int pos;
  int tval;

  NumToString (val, str);
  strcpy (str, PtoCstr (str));  
/*
  if (val == 0)
    {
    str[0] = '0';
    return (str);
    }
    
  if (val < 0)
    {
    str[i] = '-';
    i= 1;
    }
    
  pos = i;  
  tval = val;
  while (tval != 0)
    {
    tval /= radix;
    pos++;  
    }
  
  str[pos] ='\0';
  pos--;
  while (val != 0)
    {
    str[pos] = (char)((int)'0' + val % radix);
    val /= radix;
    pos--;
    }
  */
  return (str);  
  }
    
int kbhit ()
  {
  EventRecord event;
  
  if (EventAvail (keyDownMask | autoKey, &event))
    return (1);
  else
    return(0);
  }

int getch (void)
  {
  EventRecord event;
  
  if (GetNextEvent (keyDownMask | autoKey, &event))
    return ((char)(event.message & 0x000000ff));
  }
  
int biostime (int cmd, long newtime)
  {
  return (TickCount() / 3 * 50);
  }

void clrscr (void)
  {
  }

void sound (unsigned int freq)
  {
  if (freq == 440)
    SysBeep(1);
  }

void nosound (void)
  {
  }
  
void delay (unsigned int ms)
  {
  long sysTime;
  Delay (ms*3/50 , &sysTime);
  }
  
int getmaxx (void)
  {
  return (640);
  }

int getmaxy (void)
  {
  return (480);
  }

void line (int x1, int y1, int x2, int y2)
  {
  RGBForeColor (&textcolor);
  MoveTo (x1, y1);
  LineTo (x2, y2);
  }
  
void lineto (int x1, int y1)
  {
  RGBForeColor (&textcolor);
  LineTo (x1, y1);
  }
  
void moveto (int x1, int y1)
  {
  MoveTo (x1, y1);
  }
  
void bar (int x1, int y1, int x2, int y2)
  {
  Rect r;
  
  RGBForeColor (&fillcolor);
  SetRect (&r, x1, y1, x2+1, y2+1);
  PaintRect (&r);
  }
  
void rectangle ( int x1, int y1, int x2, int y2)
  {
  RGBForeColor (&textcolor);
  MoveTo (x1, y1);
  LineTo (x2, y1);
  LineTo (x2, y2);
  LineTo (x1, y2);
  LineTo (x1, y1);
  }
      
void outtextxy (int x1, int y1, char *msg)
  {
  int len;
  BigString tmpstr;
  
  RGBForeColor (&textcolor);
  len = strlen (msg) - 1;
  if (msg[len] == '\n') msg[len] = '\0';
  strcpy (tmpstr, msg);
  CtoPstr (tmpstr);
  
  if (theight == 11)
    MoveTo (x1, y1-1);
  else
    MoveTo (x1, y1);
  DrawString (tmpstr);
  }

void getimage (int x1, int y1, int x2, int y2, char *data)
  {
  Rect from, dest;
  long rb;
 
  SetPort (myCGrafPtr);

  ForeColor (blackColor);
  BackColor (whiteColor);
  
  macimg = (struct macimg *)data;
  macimg->x = x2;
  macimg->y = y2;

  rb = (((8 * (x2 - x1)) + 15) >> 4) << 1;

  SetRect (&from, x1, y1, x2, y2);
  SetRect (&dest, x1, y1, x2, y2); 
    
  (**(*myCGrafPtr).portPixMap).baseAddr = data+4;
  (**(*myCGrafPtr).portPixMap).rowBytes = rb + 0x8000;
  (**(*myCGrafPtr).portPixMap).bounds = from;
    
  CopyBits (&(*mainWin).portBits, (BitMap *)*(*myCGrafPtr).portPixMap, 
            &from, &dest, srcCopy, 0); 
  
  SetPort (mainWin);
  }
    
void putimage (int x1, int y1, char *data, int action)
  {
  Rect from, dest;
  int x2, y2;
  long rb;
 
  ForeColor (blackColor);
  BackColor (whiteColor);
  
  macimg = (struct macimg *)data;
  x2 = macimg->x;
  y2 = macimg->y;

  rb = (((8 * (x2 - x1)) + 15) >> 4) << 1;
  
  SetRect (&from, x1, y1, x2, y2);
  SetRect (&dest, x1, y1, x2, y2);

  (**(*myCGrafPtr).portPixMap).baseAddr = data+4;
  (**(*myCGrafPtr).portPixMap).rowBytes = rb + 0x8000;
  (**(*myCGrafPtr).portPixMap).bounds = dest;
  
  CopyBits ((BitMap *)*(*myCGrafPtr).portPixMap, &(*mainWin).portBits, 
            &from, &dest, srcCopy, 0); 

  SetPort (mainWin);
  }

long imagesize (int x1, int y1, int x2, int y2)
  {
  long size;
  
  size = (((long)(x2-x1) * 8L + 15) / 16) * 2 * (long)(y2-y1);
  return (size);
  } 

void GSwritergbpalette (char *pal)
  {
  int i;
  
  for (i=0; i<16; i++)
    {
    macrgb[i].red = ((int)pal[3*i] * 4) << 8;
    macrgb[i].green = ((int)pal[3*i+1] * 4) << 8;
    macrgb[i].blue = ((int)pal[3*i+2] * 4) << 8;
    }
  }

void setcolor (int color)
  {
  textcolor.red = macrgb[color].red;
  textcolor.green = macrgb[color].green;
  textcolor.blue = macrgb[color].blue;
  }
  
void setfillstyle (int pattern, int color)
  {  
  fillcolor.red = macrgb[color].red;
  fillcolor.green = macrgb[color].green;
  fillcolor.blue = macrgb[color].blue; 
  }
  
void settextstyle (int font, int dir, int size)
  {
  if (size) 
    {
    TextFont (0);
    TextFace (0);
    TextSize(12);
    theight = 11;
    }
  else
    {
    theight = 10;
    TextFont (1);
    TextFace (0);
    TextSize (10);
    }
  }
  
void setlinestyle (int style, unsigned int pattern, int thickness)
  {
  PenSize (thickness, thickness);
  }

void settextjustify (int horiz, int vert)
  {
  }
    
int textwidth (char *str)
  {
  BigString tmpstr;
  
  strcpy (tmpstr, str);
  return (StringWidth (CtoPstr(tmpstr)));
  }
  
int textheight (char *str)
  {
  return (theight);
  }
  
void setwritemode (int mode)
  {
  PenMode (mode);
  }
  
void initgraph(int *driver, int *mode, char *path)
  {
  GDHandle gd;
  int COLOR;
  Rect mr;
  int err;
  CTabHandle cmhandle;
   
  gd = GetGDevice ();
  COLOR = TestDeviceAttribute (gd, 0);
  MaxApplZone ();
  InitGraf (&thePort);
  
  InitFonts ();
  InitWindows ();
  TEInit ();
  InitDialogs (0L);
  SetRect (&mr, 0, 0, 640, 480);
  mainWin = NewCWindow (0, &mr, "\p", 1, plainDBox, (WindowPtr) -1, 0, 0L);
  SetPort (mainWin);
  BringToFront (mainWin);
  settextstyle (0, 0, 1);
  FlushEvents (everyEvent, 0);


  /*  Initialize backing store port  */
  myCGrafPtr = &myCGrafPort;
  OpenCPort (myCGrafPtr);
  device = GetMaxDevice (&(*mainWin).portRect);
  olddevice = GetGDevice ();
  cmhandle = (**(**device).gdPMap).pmTable;
  err = HandToHand (&cmhandle);
  (**(*myCGrafPtr).portPixMap).pmTable = cmhandle;
  
  /*  init sound  */
/*
  err = SndNewChannel (snd, 1, 0x000000C0, NULL);
  sndcmd.cmd = 40;
  sndcmd.param1 = 2000;
  sndcmd.param2 = 0xff0105A0;
  SndDoCommand (*snd, &sndcmd, TRUE);
*/  
  }
  
void closegraph (void)
  {
  FlushEvents (everyEvent, 0);
  ExitToShell ();
  }
          

/*  -------------- mouse routines --------------  */
#include "mouse.h"

void mouse_off (void)
  {
  HideCursor ();
  }
  
void mouse_on (void)
  {
  ShowCursor ();
  }
  
void get_mouse_position (int *x, int *y)
  {
  Point p;
  
  GetMouse (&p);
  *x = p.h;
  *y = p.v;
  }
   
void set_mouse_position (int x, int y)
  {
  }
  
void set_mouse_borders (int x1, int y1, int x2, int y2)
  {
  }
  
int get_mouse_release (int btn, int *x, int *y, int *stat)
  {
  Point p;
  
  if (StillDown ())
    {
    *stat = 1;
    GetMouse (&p);
    *x = p.h;
    *y = p.v;
    return (0);
    }
  *stat = 1;
  GetMouse (&p);
  *x = p.h;
  *y = p.v;
  return (1);  
  }
  
void reset_mouse (void)
  {
  InitCursor ();
  }
  
int get_mouse_press (int btn, int *x, int *y, int *stat)
  {
  EventRecord event;
  
  if (GetNextEvent (mDownMask, &event))
    {
    *stat = 1;
    *x = event.where.h;
    *y = event.where.v;
    return(1);
    }
  return (0);
  
  }
  
int mouse_present (void)
  {
  return (TRUE);
  }
  
/* -------------  video routines  --------------*/

void GSdisablevideo (void);
void GSenablevideo (void);

void GSdisablevideo (void)
  {
  }
  
void GSenablevideo (void)
  {
  }
