
/*  A Bison parser, made from ifparse.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse ifparse
#define yylex iflex
#define yyerror iferror
#define yylval iflval
#define yychar ifchar
#define yydebug ifdebug
#define yynerrs ifnerrs
#define	PALETTE	258
#define	END	259
#define	ALIAS	260
#define	HIGHLT	261
#define	SPEEDUP	262
#define	BUTTONSTUFF	263
#define	CANCEL	264
#define	FUNCTION	265
#define	REDRAWFUNC	266
#define	POPUPM	267
#define	PLABEL	268
#define	WIND	269
#define	FIELD	270
#define	GSRECT	271
#define	LINE	272
#define	DRAGAREA	273
#define	GSMSG	274
#define	COLORLIST	275
#define	GSINT	276
#define	LABEL	277
#define	BUTTON	278
#define	NAME	279
#define	STRING	280

#line 1 "ifparse.y"

/* geosim includes and globals go here */ 
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "geosim.h"
#include "gspriv.h"

#define alloca malloc
#define yynerrs ifnerrs /* to avoid a link error */

/* These are vars from readinterfacefilepass1 */
extern int msgs, aliases, functions, windows, popups, fields;
extern int windata[MAXWINDOW][2], popdata[MAXPOPUP];
extern boolean firstPass;
extern char *Colorlist[];
char *nullString = "";

/* These are from readinterfacefile */
extern  int        currmsg;             /* Index for current message */
extern   int        currpop;             /* Index for current popup menu */
extern   int        currplab;                 /* Index for current label in current
                                          popup menu */
extern   int        currwin;             /* Index for current window */
extern   int        currbutt;                 /* Index for current button in current
                                          window */
extern   int        currgraphic;              /* Index for current graphic in current
                                          window */
extern   int        currfield;           /* Index for current field */
extern   int        currfunc;            /* Index for current function */
extern   int        currcolor;
extern   int        clist;  
extern   int        curr_alias;           /* Why not -1? CAS *//* Index for current alias*/

/* These are geosim globals */
extern Iconfig InfState;      /* Current state of the interface */
extern Popupmenu *Popups;   /* All of the popup menus */
extern GSWindow *Win; /* All of the windows */
extern char *Alias[MAXALIASES+1];           /* color aliases for file */
extern char *Acolor[MAXALIASES+1]; /* colors for aliases */

extern char Interface_Palette[3*256];
extern IntrFunction FuncNames[]; /* Association of function names to ptrs */
extern int NumFuncs;  /* The number of elements in FuncNames */

/* NOTE: the tokens NAME and STRING have text associated with them.
The memory for this text is allocated dynamically (in the lexer) and
must be free()d if not used.
*/

void yyerror(char *msg);
int yylex();
 /* prototypes required in CW - hope yylex is right */


#line 57 "ifparse.y"
typedef union {
	int val;
	char *text;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		189
#define	YYFLAG		-32768
#define	YYNTBASE	28

#define YYTRANSLATE(x) ((unsigned)(x) <= 280 ? yytranslate[x] : 51)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    26,
    27,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     7,     9,    11,    13,    15,    17,    19,
    21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
    41,    43,    45,    47,    49,    56,    64,    66,    72,    77,
    82,    91,    99,   107,   114,   122,   127,   133,   145,   158,
   166,   175,   190,   208,   217,   225,   235,   246,   256
};

static const short yyrhs[] = {    29,
     0,    28,    29,     0,    30,     0,    31,     0,    32,     0,
    33,     0,    34,     0,    35,     0,    36,     0,    37,     0,
    38,     0,    39,     0,    40,     0,    42,     0,    43,     0,
    44,     0,    45,     0,    47,     0,    46,     0,    48,     0,
    49,     0,    50,     0,    41,     0,     3,     0,    26,    24,
    21,    21,    21,    27,     0,    26,    24,    21,    21,    21,
    21,    27,     0,     4,     0,     5,    26,    24,    24,    27,
     0,     6,    26,    24,    27,     0,     7,    26,    21,    27,
     0,    20,    26,    24,    24,    24,    24,    24,    27,     0,
     8,    26,    24,    21,    24,    24,    27,     0,     9,    26,
    24,    24,    24,    24,    27,     0,    10,    26,    24,    21,
    21,    27,     0,    10,    26,    24,    21,    21,    21,    27,
     0,    11,    26,    24,    27,     0,    19,    26,    24,    25,
    27,     0,    12,    26,    24,    21,    21,    24,    24,    24,
    24,    21,    27,     0,    12,    26,    24,    21,    21,    24,
    24,    24,    24,    21,    24,    27,     0,    13,    26,    24,
    21,    24,    25,    27,     0,    13,    26,    24,    21,    24,
    25,    21,    27,     0,    14,    26,    24,    21,    21,    21,
    21,    24,    24,    24,    21,    21,    21,    27,     0,    23,
    26,    24,    25,    21,    21,    21,    21,    24,    24,    24,
    24,    21,    21,    21,    24,    27,     0,    22,    26,    21,
    21,    24,    25,    24,    27,     0,    22,    26,    21,    21,
    24,    25,    27,     0,    15,    26,    24,    21,    21,    21,
    21,    24,    27,     0,    16,    26,    21,    21,    21,    21,
    24,    21,    24,    27,     0,    17,    26,    21,    21,    21,
    21,    21,    24,    27,     0,    18,    26,    24,    21,    21,
    21,    21,    24,    24,    21,    27,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    71,    71,    74,    74,    74,    74,    74,    74,    75,    75,
    75,    75,    75,    75,    76,    76,    76,    76,    76,    76,
    77,    77,    77,    80,    83,   120,   133,   140,   158,   168,
   176,   201,   215,   222,   245,   268,   281,   297,   332,   368,
   399,   430,   464,   524,   547,   569,   589,   617,   640
};

static const char * const yytname[] = {   "$","error","$illegal.","PALETTE",
"END","ALIAS","HIGHLT","SPEEDUP","BUTTONSTUFF","CANCEL","FUNCTION","REDRAWFUNC",
"POPUPM","PLABEL","WIND","FIELD","GSRECT","LINE","DRAGAREA","GSMSG","COLORLIST",
"GSINT","LABEL","BUTTON","NAME","STRING","'('","')'","gs_interface","gs_line",
"palette_spec","palette_entry","end","alias","highlight","speedup","colorlist",
"buttonstuff","cancel","function","redrawfunc","msg","popup","plabel","window",
"button","label","field","rect","line","dragarea",""
};
#endif

static const short yyr1[] = {     0,
    28,    28,    29,    29,    29,    29,    29,    29,    29,    29,
    29,    29,    29,    29,    29,    29,    29,    29,    29,    29,
    29,    29,    29,    30,    31,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    39,    40,    41,    42,    42,    43,
    43,    44,    45,    46,    46,    47,    48,    49,    50
};

static const short yyr2[] = {     0,
     1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     6,     7,     1,     5,     4,     4,
     8,     7,     7,     6,     7,     4,     5,    11,    12,     7,
     8,    14,    17,     8,     7,     9,    10,     9,    11
};

static const short yydefact[] = {     0,
    24,    27,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     1,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    23,    14,    15,    16,    17,    19,
    18,    20,    21,    22,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     2,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    29,    30,     0,     0,     0,    36,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    37,     0,     0,     0,     0,     0,     0,
     0,    34,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    25,    32,    33,    35,     0,     0,    40,
     0,     0,     0,     0,     0,     0,     0,    45,     0,    26,
     0,    41,     0,     0,     0,     0,     0,    31,    44,     0,
     0,     0,    46,     0,    48,     0,     0,     0,     0,    47,
     0,     0,     0,    38,     0,    49,     0,    39,     0,     0,
     0,     0,    42,     0,     0,     0,    43,     0,     0
};

static const short yydefgoto[] = {    22,
    23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    43,    44
};

static const short yypact[] = {    24,
-32768,-32768,   -25,   -24,    -1,    19,    26,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
    47,     0,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    48,    49,    53,    51,    52,    54,
    55,    56,    57,    58,    59,    63,    64,    62,    65,    66,
    67,    68,    70,-32768,    69,    50,    60,    73,    71,    75,
    72,    76,    77,    79,    80,    81,    82,    83,    84,    86,
    85,    87,    90,    78,-32768,-32768,    89,    91,    93,-32768,
    95,    94,    96,    98,    99,   100,   101,    97,   102,   103,
   104,   107,-32768,   105,   106,    27,   108,   109,   110,   112,
   114,   115,   116,-32768,   117,   113,   118,    28,   119,   120,
   121,-32768,   125,    30,   122,   123,   126,   124,   130,   128,
    -3,   132,   127,-32768,-32768,-32768,-32768,   131,   129,-32768,
   133,   134,   138,   136,   137,   135,   139,-32768,   142,-32768,
   140,-32768,   141,   143,   144,   145,   147,-32768,-32768,   149,
   146,   150,-32768,   148,-32768,   155,   153,    29,   157,-32768,
   152,   156,   154,-32768,   161,-32768,   159,-32768,   163,   164,
   160,   165,-32768,   167,   166,   162,-32768,   169,-32768
};

static const short yypgoto[] = {-32768,
   170,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768
};


#define	YYLAST		192


static const short yytable[] = {   188,
    45,    46,     1,     2,     3,     4,     5,     6,     7,     8,
     9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
   147,    19,    20,   148,    47,    21,     1,     2,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    48,    19,    20,   121,   133,    21,
   139,    49,   173,   122,   134,   174,   140,    50,    51,    52,
    53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
    63,    65,    66,    67,    68,    69,    85,    70,    71,    72,
    73,    74,    75,    76,    77,    78,    86,    81,    79,    80,
    83,    82,    84,    87,    88,    89,    91,    92,    90,    93,
    94,    95,    96,    97,   103,   100,     0,     0,    98,    99,
   102,   101,   104,   106,   105,   107,   109,   108,   110,   111,
   112,   113,     0,   114,   117,   115,   116,   118,   119,   120,
   125,   123,   126,   124,   127,   128,   129,   131,   132,     0,
   130,     0,   141,   142,   144,   135,   136,   137,   138,   143,
   145,   146,   149,   150,   151,   152,   153,   154,   155,   156,
   157,   158,   160,   161,   162,   159,   168,   164,   189,   163,
   166,   165,   167,   169,   170,   171,   172,   175,   176,   177,
   178,   179,   180,   181,   182,   184,   183,   185,   187,   186,
     0,    64
};

static const short yycheck[] = {     0,
    26,    26,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    24,    22,    23,    27,    26,    26,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    26,    22,    23,    21,    21,    26,
    21,    26,    24,    27,    27,    27,    27,    26,    26,    26,
    26,    26,    26,    26,    26,    26,    26,    26,    26,    26,
    24,    24,    24,    21,    24,    24,    27,    24,    24,    24,
    24,    24,    24,    21,    21,    24,    27,    21,    24,    24,
    21,    24,    24,    21,    24,    21,    21,    21,    27,    21,
    21,    21,    21,    21,    27,    21,    -1,    -1,    25,    24,
    21,    25,    24,    21,    24,    21,    21,    24,    21,    21,
    21,    21,    -1,    27,    21,    24,    24,    21,    24,    24,
    21,    24,    21,    25,    21,    21,    21,    25,    21,    -1,
    24,    -1,    21,    21,    21,    27,    27,    27,    24,    24,
    21,    24,    21,    27,    24,    27,    24,    24,    21,    24,
    24,    27,    21,    24,    24,    27,    21,    24,     0,    27,
    24,    27,    24,    24,    27,    21,    24,    21,    27,    24,
    27,    21,    24,    21,    21,    21,    27,    21,    27,    24,
    -1,    22
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/local/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 24:
#line 80 "ifparse.y"
{
		;
    break;}
case 25:
#line 83 "ifparse.y"
{
		if (firstPass)	{
			}
		else {
			/* Look for this color in the palette.  If it's
			already there, and not a "standard" color, overwrite
			the original specification. */
			int p;
			p = GSiselword(yyvsp[-4].text, Colorlist);
			if (p == -1)  { /* not found */
				if (currcolor > GraphicsMode) { /* overwrite old colors */
					if (currcolor >= GraphicsMode + NUM_DFLT_COLORS) {
						GSelog(-1, "Too many colors.\n"
							"Palette was initialized with %d colors.\n"
							"Last color: |%s|.\n", 
									GraphicsMode, yyvsp[-4].text);
						}
					else {
						p = currcolor + NUM_STD_COLORS - GraphicsMode;
						free(Colorlist[p]);
						}
					}
				else { /* enter color in next avail. palette slot */
					p = currcolor;
					Colorlist[p+1] = NULL;
					}
				currcolor++;
				Colorlist[p] = yyvsp[-4].text;
				}
			if (p >= NUM_STD_COLORS) {
				Interface_Palette[p*3] = (char) yyvsp[-3].val;
				Interface_Palette[p*3+1] = (char) yyvsp[-2].val;
				Interface_Palette[p*3+2] = (char) yyvsp[-1].val;
				}
			}
		;
    break;}
case 26:
#line 120 "ifparse.y"
{
		if (firstPass)	{
			}
		else {
			/* let's hope no one actually sees this ... */
			GSelog(-1, "This interface file uses an old"
				" palette entry syntax.\n  You can no longer"
				" set the index of a palette entry in the "
				"interface file.\n  Please contact Project "
				"GeoSim about this problem.\n");
			}
		;
    break;}
case 27:
#line 133 "ifparse.y"
{
		if (firstPass)	{
			}
		else {
			}
		;
    break;}
case 28:
#line 140 "ifparse.y"
{
		if (firstPass)	{
			aliases++;
			}
		else {
			if (curr_alias == MAXALIASES)
			  GSelog(-1, "Too many aliases.\n");
			Alias[curr_alias] = yyvsp[-2].text;
			Acolor[curr_alias] = yyvsp[-1].text;
			if ((Alias[curr_alias]==NULL)||
				(Acolor[curr_alias]==NULL))
			  GSelog(-1, "Out of memory for alias |%s|.\n",
				yyvsp[-2].text);
			curr_alias++;
			Alias[curr_alias] = nullString;
			}
		;
    break;}
case 29:
#line 158 "ifparse.y"
{
		if (firstPass)	{
			}
		else {
			InfState.highlight = 
				convertcolor(Alias,Acolor,yyvsp[-1].text);
			free(yyvsp[-1].text);
			}
		;
    break;}
case 30:
#line 168 "ifparse.y"
{
		if (firstPass)	{
			}
		else {
			InfState.speedup = yyvsp[-1].val;
			}
		;
    break;}
case 31:
#line 176 "ifparse.y"
{
		if (firstPass) {
			}
		else {
			if (clist == 5)
			  GSelog(-1, "Too many colorlists.\n");
			InfState.colorlist[clist][0] =
				convertcolor(Alias,Acolor,yyvsp[-5].text);
			InfState.colorlist[clist][1] =
				convertcolor(Alias,Acolor,yyvsp[-4].text);
			InfState.colorlist[clist][2] =
				convertcolor(Alias,Acolor,yyvsp[-3].text);
			InfState.colorlist[clist][3] =
				convertcolor(Alias,Acolor,yyvsp[-2].text);
			InfState.colorlist[clist][4] =
				convertcolor(Alias,Acolor,yyvsp[-1].text);
			free(yyvsp[-5].text);
			free(yyvsp[-4].text);
			free(yyvsp[-3].text);
			free(yyvsp[-2].text);
			free(yyvsp[-1].text);
			clist++;
			}
		;
    break;}
case 32:
#line 201 "ifparse.y"
{
		if (firstPass)	{
			}
		else {
		InfState.buttonborder=convertcolor(Alias,Acolor,yyvsp[-4].text);
		InfState.diagonals = yyvsp[-3].val;
		InfState.buttonTLcolor=convertcolor(Alias,Acolor,yyvsp[-2].text);
		InfState.buttonBRcolor=convertcolor(Alias,Acolor,yyvsp[-1].text);
		free(yyvsp[-4].text);
		free(yyvsp[-2].text);
		free(yyvsp[-1].text);
			}
		;
    break;}
case 33:
#line 215 "ifparse.y"
{
		if (firstPass)	{
			}
		else {
			}
		;
    break;}
case 34:
#line 222 "ifparse.y"
{
		if (firstPass)	{
			functions++;
			}
		else {
			Function *myfunc;
			currfunc++;
			myfunc = &(InfState.funcs[currfunc]);
			myfunc->dtime = yyvsp[-2].val;
			myfunc->active = yyvsp[-1].val;
			myfunc->mouse_off = TRUE;
			if (strlen(yyvsp[-3].text) > INFNAMELEN)
			  GSelog(0, "Function name too long: |%s|.\n",
					yyvsp[-3].text);
			myfunc->name = yyvsp[-3].text;
			if (myfunc->name == NULL)
			  GSelog(-1, "Out of memory for function |%s|.\n",
			    yyvsp[-3].text);
			myfunc->func = (boolean(*)(int, int, int, ...))getfunctionptr(yyvsp[-3].text);
			myfunc->itime = -1;
			}
		;
    break;}
case 35:
#line 245 "ifparse.y"
{
		if (firstPass)	{
			functions++;
			}
		else {
			Function *myfunc;
			currfunc++;
			myfunc = &(InfState.funcs[currfunc]);
			myfunc->dtime = yyvsp[-3].val;
			myfunc->active = yyvsp[-2].val;
			myfunc->mouse_off = yyvsp[-1].val;
			if (strlen(yyvsp[-4].text) > INFNAMELEN)
			  GSelog(0, "Function name too long: |%s|.\n",
					yyvsp[-4].text);
			myfunc->name = yyvsp[-4].text;
			if (myfunc->name == NULL)
			  GSelog(-1, "Out of memory for function |%s|.\n",
			    yyvsp[-4].text);
			myfunc->func = (boolean(*)(int, int, int, ...))getfunctionptr(yyvsp[-4].text);
			myfunc->itime = -1;
			}
		;
    break;}
case 36:
#line 268 "ifparse.y"
{
		if (firstPass)	{
			}
		else {
			int d1;

			d1 = getname(&FuncNames, sizeof(IntrFunction),
					NumFuncs, yyvsp[-1].text, "function");
			InfState.redrawfunc = 
				(void(*)(void))FuncNames[d1].funcptr;
			free(yyvsp[-1].text);
			}
		;
    break;}
case 37:
#line 281 "ifparse.y"
{
		if (firstPass)	{
			msgs++;
			}
		else {
			Message *msg;
			currmsg++; 
			msg = &(InfState.msgs[currmsg]);
			msg->name = yyvsp[-2].text; 
			msg->text = yyvsp[-1].text; 
			if ((msg->name==NULL)||(msg->text==NULL))
			  GSelog(-1, "Out of memory for message |%s|.\n",
					yyvsp[-2].text);
			}
		;
    break;}
case 38:
#line 297 "ifparse.y"
{
		if (firstPass)	{
			popups++;
			if (popups+1 == MAXPOPUP)
			  GSelog(-1, "Too many popup menus declared in interface file\n");
			popdata[popups] = 0;
			}
		else {
			Popupmenu *curpop;
			currpop++;
			curpop = &(Popups[currpop]);
			if (strlen(yyvsp[-8].text) > INFNAMELEN)	
			  GSelog(0, "Name too long: |%s|.\n",yyvsp[-8].text);
			curpop->name = yyvsp[-8].text;
			if (curpop->name == NULL)
			  GSelog(-1, "Out of mempry for popup |%s|.\n",
						yyvsp[-8].text);
			curpop->x = yyvsp[-7].val;
			curpop->y = yyvsp[-6].val;
			curpop->wd = 0;
			curpop->active = FALSE;
			curpop->bg = convertcolor(Alias, Acolor,yyvsp[-3].text);
			curpop->enablefg = convertcolor(Alias, Acolor,yyvsp[-5].text);
			curpop->disablefg=convertcolor(Alias, Acolor,yyvsp[-4].text);
			curpop->bcolor=convertcolor(Alias, Acolor,yyvsp[-2].text);
			curpop->checklist=yyvsp[-1].val;
			currplab = -1;
			curpop->func=NULL;
			free(yyvsp[-5].text);
			free(yyvsp[-4].text);
			free(yyvsp[-3].text);
			free(yyvsp[-2].text);
			}
		;
    break;}
case 39:
#line 332 "ifparse.y"
{
		if (firstPass) {
			popups++;
			if (popups+1 == MAXPOPUP)
			  GSelog(-1, "Too many popup menus declared in interface file\n");
			popdata[popups] = 0;
			}
		else {
			Popupmenu *curpop;
			currpop++;
			curpop = &(Popups[currpop]);
			if (strlen(yyvsp[-9].text) > INFNAMELEN)	
			  GSelog(0, "Name too long: |%s|.\n",yyvsp[-9].text);
			curpop->name = yyvsp[-9].text;
			if (curpop->name == NULL)
			  GSelog(-1, "Out of mempry for popup |%s|.\n",
						yyvsp[-9].text);
			curpop->x = yyvsp[-8].val;
			curpop->y = yyvsp[-7].val;
			curpop->wd = 0;
			curpop->active = FALSE;
			curpop->bg = convertcolor(Alias, Acolor,yyvsp[-6].text);
			curpop->enablefg = convertcolor(Alias, Acolor,yyvsp[-5].text);
			curpop->disablefg=convertcolor(Alias, Acolor,yyvsp[-4].text);
			curpop->bcolor=convertcolor(Alias, Acolor,yyvsp[-3].text);
			curpop->checklist=yyvsp[-2].val;
			currplab = -1;
			curpop->func=(boolean(*)(void))getfunctionptr(yyvsp[-1].text);
			free(yyvsp[-6].text);
			free(yyvsp[-5].text);
			free(yyvsp[-4].text);
			free(yyvsp[-3].text);
			free(yyvsp[-1].text);
			}
		;
    break;}
case 40:
#line 368 "ifparse.y"
{
		if (firstPass)	{
			popdata[popups]++;
			}
		else {
			Menuitem *curritem;
			FontSizeType oldfont;
			int len;
			currplab++;
			curritem = &(Popups[currpop].item[currplab]);
			curritem->name = yyvsp[-4].text;
			if (curritem->name == NULL)
				GSelog(-1, "Out of memory for plabel |%s|.\n",yyvsp[-4].text);
			curritem->active = (MenuItemStatusType) yyvsp[-3].val;
			curritem->func = (boolean(*)(char *))getfunctionptr(yyvsp[-2].text);
			curritem->text = yyvsp[-1].text;
			if (curritem->text == NULL)
				GSelog(-1, "Out of memory for plabel |%s|.\n",yyvsp[-4].text);
			curritem->checked = FALSE;
			oldfont = GSPgetfont();
			GSsetfont(LARGE);
			len = GStextwidth(curritem->text) + 2*POPUPOFFSET;
			GSsetfont(oldfont);
			if (Popups[currpop].checklist)
				len += CHECKWID;
			if (len > Popups[currpop].wd)
				Popups[currpop].wd = len;
			free(yyvsp[-2].text);
			}
		;
    break;}
case 41:
#line 399 "ifparse.y"
{
		if (firstPass)	{
			popdata[popups]++;
			}
		else {
			Menuitem *curritem;
			FontSizeType oldfont;
			int len;
			currplab++;
			curritem = &(Popups[currpop].item[currplab]);
			curritem->name = yyvsp[-5].text;
			if (curritem->name == NULL)
				GSelog(-1, "Out of memory for plabel |%s|.\n",yyvsp[-5].text);
			curritem->active = (MenuItemStatusType) yyvsp[-4].val;
			curritem->func = (boolean(*)(char *))getfunctionptr(yyvsp[-3].text);
			curritem->text = yyvsp[-2].text;
			if (curritem->text == NULL)
				GSelog(-1, "Out of memory for plabel |%s|.\n",yyvsp[-5].text);
			curritem->checked = yyvsp[-1].val;
			oldfont = GSPgetfont();
			GSsetfont(LARGE);
			len = GStextwidth(curritem->text) + 2*POPUPOFFSET;
			GSsetfont(oldfont);
			if (Popups[currpop].checklist)
				len += CHECKWID;
			if (len > Popups[currpop].wd)
				Popups[currpop].wd = len;
			free(yyvsp[-3].text);
			}
		;
    break;}
case 42:
#line 430 "ifparse.y"
{
		if (firstPass)	{
			windows++;
			if (windows+1 == MAXWINDOW)
			  GSelog(-1, "Too many windows declared in interface file\n");
			windata[windows][0] = windata[windows][1] = 0;
			}
		else {
			currwin++;
			currbutt=-1;
			currgraphic=-1;
			
			if (strlen(yyvsp[-11].text) > INFNAMELEN)
				GSelog(0, "Name too long: |%s|.\n", yyvsp[-11].text);
			Win[currwin].name = yyvsp[-11].text;
			if (Win[currwin].name == NULL)
				GSelog(-1, "Out of memory for window |%s|.\n", yyvsp[-11].text);
			Win[currwin].x = yyvsp[-10].val;
			Win[currwin].y = yyvsp[-9].val;
			Win[currwin].wd = yyvsp[-8].val;
			Win[currwin].ht = yyvsp[-7].val;
			Win[currwin].popup = FALSE;
			Win[currwin].fgcolor = convertcolor(Alias, Acolor, yyvsp[-6].text);
			Win[currwin].bgcolor = convertcolor(Alias, Acolor, yyvsp[-5].text);
			Win[currwin].bordercolor = convertcolor(Alias, Acolor, yyvsp[-4].text);
			Win[currwin].bordersize = yyvsp[-3].val;
			Win[currwin].active = yyvsp[-2].val;
			Win[currwin].bstore_to_use = yyvsp[-1].val;
			free(yyvsp[-6].text);
			free(yyvsp[-5].text);
			free(yyvsp[-4].text);
			}
		;
    break;}
case 43:
#line 465 "ifparse.y"
{
		if (firstPass)	{
			windata[windows][0]++;
			}
		else {
			GSButton *bt;
			if (currwin == -1)
				GSelog(-1, "No active window for line.\n");
			currbutt++;
			bt = &(Win[currwin].wb[currbutt]);
			if (strlen(yyvsp[-14].text) > INFNAMELEN)
				GSelog (0, "Name too long: |%s|\n", yyvsp[-14].text);
			bt->name = yyvsp[-14].text;
			if (bt->name == NULL)
				GSelog (-1, "Out of memory for button name - |%s|.\n", yyvsp[-14].text);
			if (strlen(yyvsp[-13].text) > INFNAMELEN)
				GSelog (0, "Label too long: |%s|\n", yyvsp[-13].text);
				
			bt->arrow = NO_ARROW_SYM; /* to start out */
			
			resolve_specials(yyvsp[-13].text, button_text_specials, (void *)bt);			
			
			bt->text = yyvsp[-13].text;
			if (bt->text == NULL)
				GSelog(-1, "Out of memory for button |%s|.\n", yyvsp[-14].text);
				
			bt->x = yyvsp[-12].val;
			bt->y = yyvsp[-11].val;
			bt->wd = yyvsp[-10].val;
			bt->ht = yyvsp[-9].val;
			bt->efgcolor = convertcolor(Alias, Acolor, yyvsp[-8].text);
			bt->dfgcolor = convertcolor(Alias, Acolor, yyvsp[-7].text);
			bt->bgcolor = convertcolor(Alias, Acolor, yyvsp[-6].text);
			bt->func = (boolean(*)(int, int, DragStatusType, ...))getfunctionptr(yyvsp[-5].text);
			bt->border = yyvsp[-4].val;
			bt->active = (ButtonStatusType) yyvsp[-3].val;
			bt->repeatable = yyvsp[-2].val;
			bt->labpos = (BtnLabPosType) yyvsp[-1].text[0];
			
			if (yyvsp[-5].text[0] == '@')	{
				/*Eventually, maybe the scanner shouldn't return @* as a name.*/
				bt->popupmenunum = \
					getname(Popups, sizeof (Popupmenu), InfState.numpopups, 
						yyvsp[-5].text+1, "popup");
				}
			else
				bt->popupmenunum = -1;
			
			bt->drag = FALSE;
			bt->depressed = FALSE;
			bt->tsize = (yyvsp[-16].val == 1)? LARGE : SMALL;
			free(yyvsp[-8].text);
			free(yyvsp[-7].text);
			free(yyvsp[-6].text);
			free(yyvsp[-5].text);
			free(yyvsp[-1].text);
			}
		;
    break;}
case 44:
#line 524 "ifparse.y"
{
		if (firstPass)	{
			windata[windows][1]++;
			}
		else {
			Graphic *gr;
			currgraphic++;
			if (currwin == -1)
				GSelog(-1, "No active window for label.\n");
			gr = &(Win[currwin].graphics[currgraphic]);
			gr->x = yyvsp[-5].val;
			gr->y = yyvsp[-4].val;
			gr->color = convertcolor(Alias, Acolor, yyvsp[-3].text);
			gr->text = yyvsp[-2].text;
			if (gr->text == NULL)
				GSelog(-1, "Out of memory for label |%s|.\n", yyvsp[-2].text);
			gr->shadowcolor = convertcolor(Alias, Acolor, yyvsp[-1].text);
			gr->type = (yyvsp[-7].val == 1)? GR_LABEL : GR_LABEL_SMALL;		
			free(yyvsp[-3].text);
			free(yyvsp[-1].text);
			}
		;
    break;}
case 45:
#line 547 "ifparse.y"
{
		if (firstPass)	{
			windata[windows][1]++;
			}
		else {
			Graphic *gr;
			currgraphic++;
			if (currwin == -1)
				GSelog(-1, "No active window for label.\n");
			gr = &(Win[currwin].graphics[currgraphic]);
			gr->x = yyvsp[-4].val;
			gr->y = yyvsp[-3].val;
			gr->color = convertcolor(Alias, Acolor, yyvsp[-2].text);
			gr->text = yyvsp[-1].text;
			if (gr->text == NULL)
				GSelog(-1, "Out of memory for label |%s|.\n", yyvsp[-1].text);
			gr->shadowcolor = -1;
			gr->type = (yyvsp[-6].val == 1)? GR_LABEL : GR_LABEL_SMALL;
			free(yyvsp[-2].text);	
			}
		;
    break;}
case 46:
#line 569 "ifparse.y"
{
		if (firstPass)	{
			fields++;
			}
		else {
			Field *fld;
			currfield++;
			fld = &(InfState.fields[currfield]);
			fld->name = yyvsp[-6].text;
			if (fld->name == NULL)
				GSelog(-1, "Out of memory for field |%s|.\n", yyvsp[-6].text);
			fld->x = yyvsp[-5].val;
			fld->y = yyvsp[-4].val;
			fld->wd = yyvsp[-3].val;
			fld->ht = yyvsp[-2].val;
			fld->color = convertcolor(Alias, Acolor, yyvsp[-1].text);
			free(yyvsp[-1].text);
			}
		;
    break;}
case 47:
#line 589 "ifparse.y"
{
		if (firstPass)	{
			windata[windows][1]++;
			}
		else {
			Graphic *gr;
			if (currwin == -1)
				GSelog(-1, "No active window for .\n");
			currgraphic++;
			gr = &(Win[currwin].graphics[currgraphic]);
			gr->x = yyvsp[-7].val;
			gr->y = yyvsp[-6].val;
			gr->wd = yyvsp[-5].val;
			gr->ht = yyvsp[-4].val;
			gr->color = convertcolor(Alias, Acolor, yyvsp[-3].text);
			if (yyvsp[-2].val == 1)
				gr->type = GR_RECT;
			else
				gr->type = GR_WRECT;
			if (GSstricmp(yyvsp[-1].text, "fill") == 0)
				gr->attrib = FILL;
			else
				gr->attrib = HOLLOW;
			free(yyvsp[-3].text);
			free(yyvsp[-1].text);
			}
		;
    break;}
case 48:
#line 617 "ifparse.y"
{
		if (firstPass)	{
			windata[windows][1]++;
			}
		else {
			Graphic *gr;
			if (currwin == -1)
				GSelog(-1, "No active window for line.\n");
			currgraphic++;
			gr = &(Win[currwin].graphics[currgraphic]);
			gr->x = yyvsp[-6].val;
			gr->y = yyvsp[-5].val;
			gr->wd = yyvsp[-4].val;
			gr->ht = yyvsp[-3].val;
			if (yyvsp[-2].val == 1)
				gr->type = GR_LINE;
			else
				gr->type = GR_WLINE;
			gr->color = convertcolor(Alias, Acolor, yyvsp[-1].text);
			free(yyvsp[-1].text);
			}
		;
    break;}
case 49:
#line 640 "ifparse.y"
{
		if (firstPass)	{
			windata[windows][0]++;
			}
		else {
			GSButton *bt;
			if (currwin == -1)
				GSelog(-1, "No active window for line.\n");
			currbutt++;
			bt = &(Win[currwin].wb[currbutt]);
			if (strlen(yyvsp[-8].text) > INFNAMELEN)
				GSelog (0, "Name too long: |%s|\n", yyvsp[-8].text);
			bt->name = yyvsp[-8].text;
			if (bt->name == NULL)
				GSelog (-1, "Out of memory for button name - |%s|.\n", yyvsp[-8].text);
			bt->x = yyvsp[-7].val;
			bt->y = yyvsp[-6].val;
			bt->wd = yyvsp[-5].val;
			bt->ht = yyvsp[-4].val;
			bt->text = NULL;
			bt->bgcolor = convertcolor(Alias, Acolor, yyvsp[-3].text);
			bt->func = (boolean(*)(int, int, DragStatusType, ...))getfunctionptr(yyvsp[-2].text);
			bt->efgcolor = NOCOLOR;
			bt->dfgcolor = NOCOLOR;
			bt->active = (ButtonStatusType) yyvsp[-1].val;
			bt->border = FALSE;
			
			bt->drag = TRUE;
			bt->depressed = FALSE;
			bt->tsize = LARGE;
			bt->arrow = NO_ARROW_SYM;
			bt->repeatable = FALSE;
			free(yyvsp[-3].text);
			free(yyvsp[-2].text);
			}
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/local/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 677 "ifparse.y"

