/* To do...

MigModel: migdecl.c is too large (32K limit?)

X-Windows: Change title of window to "Project GeoSim".

*/

/*#ifdef THINK_C
#include <MacHeaders>
#else*/
#if __MC68K__
#include <MacHeaders68K>
#else
#include <MacHeadersPPC>
#endif
#include <Palettes.h>
#include <Sound.h>
#include <QDOffscreen.h>
#include <Sound.h>

#include <SIOUX.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "geosim.h"
#include "gspriv.h"
#include "gsscreen.h"

#define APPLE_MENU 128
#define FILE_MENU 129

typedef unsigned char	uchar;

/*static CWindowPtr		Win;*/
static WindowPtr		Win;
PaletteHandle			ph=NULL;  /* should only be referenced in GSPinit_palette	*/
static GWorldPtr		Bstore[MAXBSTORES+1], RowImage;
static long				Colors[256];
static uchar			*RowBuf;
static int				Ombarht=0, Fontht, Bswd[MAXBSTORES+1], Bsht[MAXBSTORES+1], 
									Curcol, Curdepth;
static FontSizeType		Curfont;
static RgnHandle		OGrayRgn;

#ifndef REZ_MENUS
MenuHandle applem, filem;
#endif
boolean hasmbar = FALSE;
boolean CurrentlyBlack = FALSE; /* Before doing fastrow, make sure
									color is black. */
/*----------------------------------------------------------------------*/

void GSPinit_events(void) {}
void GSPclose_events(void) {}
void GSPsuspendgraphics(void) {}
void GSPrestoregraphics(void) {}
void setpalettebar(void) {}
void set_mouse_position(int x, int y) {}

void GSbell(void) { SysBeep(1); }
int mouse_present(void) { return TRUE; }
int textheight(char *str) { return Fontht; }
void GSsetlinesize(int sz) { if (sz == THIN || sz == THICK) PenSize(sz, sz); }
void GSPxormode(int on) { PenMode(on? patXor : patCopy);
						  TextMode(on? notPatCopy : patOr); }
void GSPinvertmode(int on) { PenMode(on? patXor : patCopy);
						  TextMode(on? notPatCopy : patOr);}//PenMode(on? notPatCopy : patCopy); }
void GSsetfont(FontSizeType i) { TextFace((Curfont = i) < 13? 0 : bold); }
FontSizeType GSPgetfont(void) { return Curfont; }
void GSPflush() { }

void GSsetcolor(GSColor i) { PmForeColor(Curcol = i); CurrentlyBlack=(Curcol==0); }
GSColor GSgetcolor(void) { return Curcol; }
void GSPline(int x1, int y1, int x2, int y2) { MoveTo(x1, y1); LineTo(x2, y2); }
void GSPdraw_pixel(int x, int y) { MoveTo(x,y);  Line(0,0); }
int GSPgetlinesize(void) { PenState pn; GetPenState(&pn); return(pn.pnSize.h); }
int GStextheight(char *s) {FontInfo f; GetFontInfo(&f); return(f.ascent+f.descent);}
/*int GStextwidth(char *s) {return(StringWidth(CtoPstr(s)));}*/
int GStextwidth(char *s) {int i=strlen(s); 
					return(TextWidth(s, 0, i));}
/*----------------------------------------------------------------------*/

pascal void resumeProc(void)
	{
	ExitToShell();
	}

static long myGestalt(OSType type)
{
	long response;
	OSErr err;
	if ((err=Gestalt(type, &response)) != noErr)
		GSelog(-1, "Gestalt error: %ld", err);
	return response;
}


static char translate_key(EventRecord *e)
{
	int		c;

	c = e->message & charCodeMask;

	switch (c)
	{
	case 0x03:  return KeyEnter;
	case 0x7F:  return KeyRubout;
	default:	return (c > 0  &&  c < 128)? (char) c : 0;
	}
}


void get_mouse_position(short *x, short *y)
{
	Point	p;
	
	SetPort(Win);
	GetMouse(&p);
	*x = p.h;
	*y = p.v;
}

void DoMenuCommand(long cmd)
{
	int item = LoWord(cmd);
	int menu = HiWord(cmd);
	Str255 name;
	
	switch (menu)	{
		case APPLE_MENU:
			GetItem(GetMHandle(APPLE_MENU), item, name);
			OpenDeskAcc(name);
			SetPort(Win);
			break;
		case FILE_MENU:
			if (item == 1)
				GSquit(NULL);
			break;
		}
	HiliteMenu(0);
}

int GSPnext_event(GSEvent *ev)
{
	static int	updating = FALSE;
	EventRecord	macev;
	WindowPtr	win;
	Point		winpt;

	if (updating)
	{	
		EndUpdate(Win);
		updating = FALSE;
	}
	
/*	SetPort(Win);*/
	
	while (WaitNextEvent(everyEvent, &macev, 0, 0L)) /* was eventavail - JBR*/
	{
	/*	GetNextEvent(everyEvent, &macev);*/
		winpt = macev.where;
		GlobalToLocal(&winpt);
		ev->mousex = winpt.h;
		ev->mousey = winpt.v;
		
		if (macev.what == mouseDown)  switch (FindWindow(macev.where, &win))
		{
		  case inSysWindow:
			SystemClick(&macev, win);  break;

		  case inDrag:
			DragWindow(win, macev.where, &qd.screenBits.bounds);  break;

		  case inGoAway:
			if (TrackGoAway(win, macev.where))  GSquit(NULL);
			break;

		  case inContent:
			if (win != FrontWindow()) {
				SelectWindow(win);
				break;
			} else {
				ev->type = EvMouseDown;
				return TRUE;
			}
			break;
		  case inMenuBar:
		  	if (hasmbar)
		    	DoMenuCommand(MenuSelect(macev.where));
		    break;
		}
		else switch (macev.what)
		{
		  case mouseUp:
			ev->type = EvMouseUp;
			return TRUE;
	
		  case keyDown:
		    if ((macev.modifiers & cmdKey) && (hasmbar))
		    	DoMenuCommand(MenuKey((char)(macev.message & charCodeMask)));
		    else	{
				ev->type = EvKeyDown;
				ev->key = translate_key(&macev);
				return TRUE;
				}
			break;
		  case updateEvt:
			ev->type = EvExpose;
			BeginUpdate(Win);
			updating = TRUE;
			return TRUE;

		} // end if
		
	} // end while
	
	GetMouse(&winpt);
	ev->type = EvNone;
	ev->mousex = winpt.h;
	ev->mousey = winpt.v;
	return FALSE;
}

/*----------------------------------------------------------------------*/

void GSclick(void)
{
#ifdef THINK_C
	static Handle			click = NULL;
#else
	static SndListHandle	click = NULL;
#endif
	static SndChannelPtr	channel = NULL;
	static SndCommand		quiet = { quietCmd, 0, 0 };

	if (channel == NULL)
	{
		SndNewChannel(&channel, sampledSynth, 0, NULL);
#ifdef THINK_C
		click = GetNamedResource('snd ', "\pclick");		
#else
		click = (SndListHandle) GetNamedResource('snd ', "\pclick");	
#endif	
	}

	if (click == NULL)  return;

	SndDoImmediate(channel, &quiet);
	SndPlay(channel, click, true);
}


int GShasFPU(void)
{
	return myGestalt('fpu ') > 0;
}


long GSmemavail(void)
{
	MaxApplZone();
	return MaxMem(0);
}


int GSstricmp(char *s1, char *s2) /* changed 9/11/95 - was stricmp */
{
	unsigned char	c1, c2;
	
	while (1)
	{
		c1 = tolower(*s1++);
		c2 = tolower(*s2++);
		
		if (c1 < c2)		return -1;
		else if (c1 > c2)	return  1;
		else if (c1 == 0)	return  0;
	}
}


void GSdelay(unsigned int ms) /* formerly delay() */
{
	clock_t		end;
	
	end = clock() + (clock_t) (ms*(0.001*CLOCKS_PER_SEC));
	while ( (long) (end-clock()) > 0 )   {}
}


void GSPfill_ellipse(int left, int top, int wd, int ht)
{
	Rect	r;
	
	SetRect(&r, left, top, left+wd, top+ht);
	PaintOval(&r);
}


void GSPframe_ellipse(int left, int top, int wd, int ht)
{
	Rect	r;
	
	SetRect(&r, left, top, left+wd, top+ht);
	FrameOval(&r);
}


void GSPfill_rect(int left, int top, int wd, int ht)
{
	Rect	r;

	SetRect(&r, left, top, left+wd, top+ht);
	PaintRect(&r);
}


void GSPframe_rect(int left, int top, int wd, int ht)
{
	Rect	r;
	
	SetRect(&r, left, top, left+wd, top+ht);
	FrameRect(&r);
}


void GSPset_clip_rect(int left, int top, int wd, int ht)
{
	Rect	r;
	
	SetRect(&r, left, top, left+wd, top+ht);
	ClipRect(&r);
}


GSColor GSPget_pixel(int x, int y)
{
	Rect	rowr, winr;
	uchar	c;
	int		i;

	SetPort((GrafPtr)RowImage);
	SetRect(&winr, x, y, x+1, y+1);
	SetRect(&rowr, 0, 0, 1, 1);
	CopyBits(&((GrafPtr)Win)->portBits, &((GrafPtr)RowImage)->portBits, &winr, &rowr, srcCopy, NULL);
	SetPort(Win);

	c = RowBuf[0];
	for (i = 0;  i < 256;  i++)  if (Colors[i] == c)  return i;
	return 0;
}

GSColor *GSPget_row(int r, GSColor *rowbuff)
{
	/* +++ implement better later */
	int c;
	
	for (c=0; c<SCREENWIDTH; c++)
		rowbuff[c] = GSPget_pixel(r, c);
		
	return rowbuff; /* gotta return something */
}

void GSPfastrow(int x, int y, GSColor *row, int n)
{
	Rect		winr, rowr;
	uchar		*buf;

	if (!CurrentlyBlack)
		GSsetcolor(0);

//	if (Win != FrontWindow())  return;  I don't think this is needed - JBR

	SetPort((GrafPtr)RowImage);
	SetRect(&winr, x, y, x+n, y+1);
	SetRect(&rowr, 0, 0, n, 1);

//	CopyBits(&Win->portPixMap, &RowImage->portPixMap, &winr, &rowr, srcCopy, NULL);
	for (buf = RowBuf;  n-- > 0;  buf++, row++)
		*buf = Colors[*row==255? 0 : *row];

	SetPort(Win); /* reversed these; it was CopyBits, SetPort - JBR */
	CopyBits(&((GrafPtr)RowImage)->portBits, &((GrafPtr)Win)->portBits, &rowr, &winr, srcCopy, NULL);
}


void GSPdraw_string(int x, int y, char *str)
{
	char	*c;

	for (c = str;  *c != 0;  c++)
		if (!isprint(*c))  *c = ' ';

	MoveTo(x+1, y-1);
	DrawText(str, 0, c-str);
}


void GSPfillpoly(int n, int *p)
{
	PolyHandle	poly;
	int			i;

	SetPort(Win);
	poly = OpenPoly();
	MoveTo(p[0], p[1]);
	for (i = 2;  i < 2*n;  i += 2)  LineTo(p[i], p[i+1]);

	ClosePoly();
	PaintPoly(poly);
	KillPoly(poly);
}


int textwidth(char *str)
{
	int		len;

	len = strlen(str);
	return len + TextWidth(str, 0, len);
}


void GSPinit_palette(char pal[], int n)
{
	int				i;
	char			*c;
	RGBColor		col;
	Rect			r;
	boolean			firstPalette = FALSE;
	
	SetPort(Win);
	
	if (ph != NULL)
		DisposePalette(ph);
	else
		firstPalette = TRUE;
		
	ph = NewPalette(n, NULL, pmTolerant, 0);

	for (i = 0, c = pal;  i < n;  i++, c += 3)
	{
		col.red   = ((unsigned short) c[0]) << 10;
		col.green = ((unsigned short) c[1]) << 10;
		col.blue  = ((unsigned short) c[2]) << 10;
		SetEntryColor(ph, i, &col);
	}

	SetPalette(Win, ph, FALSE);
	ActivatePalette(Win);
	for (i = 0;  i < n;  i++)  Colors[i] = Entry2Index(i);
	
	if (firstPalette) {
		SetRect(&r, 0, 0, 640, 1);
		if (NewGWorld(&RowImage, 0, &r, NULL, NULL, 0) >= 0)	{
			LockPixels(GetGWorldPixMap(RowImage));
			RowBuf = (uchar *) GetPixBaseAddr(GetGWorldPixMap(RowImage));
		}
	}
}

/*----------------------------------------------------------------------*/

int GSPinit_bstore(int bstorenum, int wd, int ht)
{
	Rect	r;
	
	Bswd[bstorenum] = Bsht[bstorenum] = 0;
	if ((wd <= 0) || (ht <= 0)) {
	Bstore[bstorenum] = NULL;
	return TRUE;
	}
	
	SetRect(&r, 0, 0, wd, ht);
	if (NewGWorld(&Bstore[bstorenum], 0, &r, NULL, NULL, 0) < 0)  return FALSE;

	LockPixels(GetGWorldPixMap(Bstore[bstorenum]));
	return TRUE;
}


int GSPto_bstore(int bstorenum, int left, int top, int wd, int ht)
{
	Rect		winr, bsr;

	if (Bswd[bstorenum] > 0)  return FALSE;  

	if (Bstore[bstorenum] == NULL)
		GSelog(-1, "Error: attempt to copy from null bstore %d.\n", bstorenum);
	SetPort((GrafPtr)Bstore[bstorenum]);
	SetRect(&winr, left, top, left+wd, top+ht);
	SetRect(&bsr, 0, 0, Bswd[bstorenum]=wd, Bsht[bstorenum]=ht);
	CopyBits(&((GrafPtr)Win)->portBits, &((GrafPtr)Bstore[bstorenum])->portBits, &winr, &bsr, 
													srcCopy, NULL);
	SetPort(Win);
	return TRUE;
}


int GSPfrom_bstore(int bstorenum, int left, int top)
{
	Rect	winr, bsr;
	
	if (Bswd[bstorenum] < 1)  return TRUE;  // should be FALSE
	
	SetPort((GrafPtr)Bstore[bstorenum]);
	SetRect(&winr, left, top, left+Bswd[bstorenum], top+Bsht[bstorenum]);
	SetRect(&bsr, 0, 0, Bswd[bstorenum], Bsht[bstorenum]);
	CopyBits(&((GrafPtr)Bstore[bstorenum])->portBits, &((GrafPtr)Win)->portBits, &bsr, &winr, 
																srcCopy, NULL);
	SetPort(Win);
	Bswd[bstorenum] = Bsht[bstorenum] = 0;
	return TRUE;
}

/*----------------------------------------------------------------------*/

void GSPinit_system(char *appl_name, int x, char **null)
{
	FontInfo		finf;
	Rect			wrect;
	int				scrwd, scrht;
	GDHandle		mainDev;
	char			menutitle[2];
	Handle			menuBar;
	MaxApplZone();
	FlushEvents(everyEvent, 0);
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitCursor();
	InitMenus();
	TEInit();
	InitDialogs(NULL); /* resume proc doesn't work yet */

	mainDev = GetMainDevice();
	
	Curdepth = (**(**mainDev).gdPMap).pixelSize;

	if (Curdepth != 8)	{
		if (SetDepth(mainDev, 8, 0, 0) != 0)
	    	GSelog(TRUE, "Screen cannot support 8-bit color.");
		}
		
	scrwd = qd.screenBits.bounds.right - qd.screenBits.bounds.left;
	scrht = qd.screenBits.bounds.bottom - qd.screenBits.bounds.top;
	wrect.right = 640 + (wrect.left = (scrwd - 640)/2);
	wrect.bottom = 480 + (wrect.top = (scrht - 480)/2);

	if (scrwd < 640  ||  scrht < 480)
		GSelog(TRUE, "Screen must be at least 640x480.");

	if (scrht < 500)
	{
		Ombarht = LMGetMBarHeight();
		LMSetMBarHeight(0);
		CopyRgn(GetGrayRgn(), OGrayRgn = NewRgn());
		RectRgn(GetGrayRgn(), &qd.screenBits.bounds);
	}
	else	{
#ifdef REZ_MENUS
		menuBar = GetNewMBar(128);
		if (menuBar == nil)
			GSelog(-1, "Can't find Mac menu bar resource.\n");
		SetMenuBar(menuBar);
		DisposHandle(menuBar);
		AddResMenu(GetMHandle(APPLE_MENU), 'DRVR');	/* add DA names to Apple menu */
		DrawMenuBar();
		hasmbar = TRUE;
#else
		menutitle[0] = (char) appleMark;
		menutitle[1] = '\0';
		applem = NewMenu(APPLE_MENU, CtoPstr(menutitle));
		AddResMenu(applem, 'DRVR');
		InsertMenu(applem, 0);
		filem = NewMenu(FILE_MENU, "\pFile");
		AppendMenu(filem, "\pQuit/Q");
		InsertMenu(filem, 0);
		DrawMenuBar();
		hasmbar = TRUE;
#endif
		}
		
	SetGDevice(GetMainDevice());
	Win = NewCWindow(NULL, &wrect, CtoPstr(appl_name), FALSE, 4, NULL, TRUE, 0);
	ShowWindow(Win);
	SelectWindow(Win);
	SetPort(Win);

	TextFont(3);  TextSize(9);    // Geneva, 9 pt
	GetFontInfo(&finf);
	Fontht = finf.ascent + finf.descent - 2;
	
	SIOUXSettings.asktosaveonclose = FALSE;
}

/*------------------------------------------------------------------------------
  Sets the file type to 'TEXT'.  This is used for postscript dumps.  The
  Finder uses this to decide whether or not to include the file in selection
  menus.
------------------------------------------------------------------------------*/
void GSPsetfiletype (
  HugeString filename
)
{
  OSErr			error;		/*--- receives error codes from ToolKit funcs ---*/
  FInfo			fndrInfo;	/*--- used to set file type ---*/
  HugeString 	errmsg;		/*--- used to hold error message for 'error' ---*/
  Str255		volname;	/*--- not used but required as parm ---*/
  short 		volnum;		/*--- default volume number ---*/
  HugeString	tempfname;
  
  strcpy(tempfname, filename);
  error = GetVol(volname, &volnum);
  if (error != noErr)
  {
    switch (error)
    {
      case nsvErr:	strcpy(errmsg, "no such volume");		break;
      default:		strcpy(errmsg, "unidentified error");	break;
    }
    GSelog(-1, "Error getting volume for file |%s| to set its type");
  }
  error = GetFInfo(CtoPstr(tempfname), volnum, &fndrInfo);
  if (error != noErr)
  {
    switch (error)
    {
      case extFSErr:	strcpy(errmsg, "external file system");	break;
      case bdNamErr:	strcpy(errmsg, "bad file name");		break;
      case fnfErr:		strcpy(errmsg, "file not found");		break;
      case ioErr:		strcpy(errmsg, "I/O error");			break;
      case nsvErr:		strcpy(errmsg, "no such volume");		break;
      case paramErr:	strcpy(errmsg, "no default volume");	break;
      default:			strcpy(errmsg, "unidentified error");	break;
    }
    GSelog(-1, "Error getting record for file |%s| to set its type: %s", filename,
           errmsg);
  }
  fndrInfo.fdType = 'TEXT';
  error = SetFInfo(CtoPstr(tempfname), volnum, &fndrInfo);
  if (error != noErr)
  {
    switch (error)
    {
      case extFSErr: 	strcpy(errmsg, "external file system");	break;
      case fLckdErr: 	strcpy(errmsg, "file locked");			break;
      case fnfErr:		strcpy(errmsg, "file not found");		break;
      case ioErr:		strcpy(errmsg, "I/O error");			break;
      case nsvErr:		strcpy(errmsg, "no such volume");		break;
      case vLckdErr:	strcpy(errmsg, "software volume lock");	break;
      case wPrErr:		strcpy(errmsg, "hardware volume lock");	break;
      default:			strcpy(errmsg, "unidentified error");	break;
    }
    GSelog(-1, "Error setting type of file |%s|: %s", filename, errmsg);
  }
}
 

void closegraph(void)
{	
	if (Ombarht > 0)
	{
		LMSetMBarHeight(Ombarht);
		CopyRgn(OGrayRgn, GetGrayRgn());
	}
	if (Win)
		DisposeWindow(Win);
	if (hasmbar) {
		DeleteMenu(APPLE_MENU);
		DeleteMenu(FILE_MENU);
		DrawMenuBar();
		}
	if (Curdepth != 8)	{
		SetDepth(GetMainDevice(), Curdepth, 0, 0);
		}
}

/*======================================================================*/
