#include <stdio.h>
#include <ctype.h>

/**********************************************************************
Return the index for entry of "list" containing "word".
Return -1 if it is not on the list.
iselword igores case.
WARNING: "list" MUST end with the "" string or this will crash your
  program!!
  
Change:
	The "list" can also end with a NULL.  I don't see a problem with
	this;  you shouldn't be trying to read from a string pointed to 0, 
	anyway.  
			JBR
**********************************************************************/
int GSiselword(char *word, char **list)
{
  int i;
  char *pt1, *pt2;

  for(i=0; (list[i] != NULL) && (list[i][0] != '\0'); i++)
  {
    for(pt1 = word, pt2 = list[i];
        *pt2 && (tolower(*pt1) == tolower(*pt2)); pt1++, pt2++);
    if((*pt1 == '\0') && (*pt2 == '\0'))
      return(i); /* found it */
  }
  return(-1);
}
